#include "stdio.h"
#include "stdlib.h"

#define height 1000
#define width 1000

int main(int argc, char **argv){

  int black = 0, gray = 0, white = 0, i = 0,n1=0,n2=0;
  int tresh1 = 0;
  float temp=0,gap=5;
  int tresh2 = 255;
  int density[100];
  FILE *fp, *fs, *fi;
  char *buf = (char *) malloc(sizeof(int));
  char *tempbuf = (char *) malloc(256);

  for(i=0;i<=100;i++) {
    density[i]=0; }
  if (argc < 4){
    printf("Usage: ./imgClean <inputfilename> <output> <thresh1> <thresh2>\n");
    exit(-1);
  }

  fp = fopen(argv[1], "r");
  fs = fopen(argv[2], "w");
  fi = fopen(argv[3], "w");
  tresh1 = atoi(argv[4]);
  tresh2 = atoi(argv[5]);
  for (i=0; i<8; i++) fscanf(fp, "%s",buf);
  fscanf(fp, "%s",buf);
  n1=atoi(buf);
  fscanf(fp, "%s",buf);
  n2=atoi(buf);
  fscanf(fp, "%s",buf);
  i=0;
  printf ("Input:\t\t%s\nOutput:\t\t%s\nTresh 1:\t\t%d\nTresh 2:\t\t%d\n",
     	  argv[1],argv[2],tresh1,tresh2);
  fprintf(fs,"P2\n#CREATOR: XV Version 3.10a  Rev: 12/29/94\n"); 
  fprintf(fs,"%d %d",n1,n2);
  fprintf(fs,"\n255\n");
  fprintf(fi,"P2\n#CREATOR: XV Version 3.10a  Rev: 12/29/94\n");
  fprintf(fi,"%d %d",n1,n2);
  fprintf(fi,"\n255\n");

while(EOF != fscanf(fp, "%s", buf)){
  temp=atoi(buf);
  density[(int)(temp*1.0/gap)]=density[(int)(temp*1.0/gap)]+1;
  
  
     if (atoi(buf) >= tresh2){
      white++;
      fprintf(fs,"%d ", 255);
      if (fprintf(fi,"%d ", 255) < 0)
	printf("write error");  }
     else if (atoi(buf) >= tresh1){
      gray++;
      fprintf(fs,"%d ", 255);
      if (fprintf(fi,"%d ", 0) < 0)
        printf("write error"); }
    else {
      black++;
      fprintf(fs,"%d ", 0);
      if (fprintf(fi,"%d ", 255) < 0)
        printf("write error");
      }
    
    
    if ((++i)%((int)17) == 0)
      if (fprintf(fs,"\n") < 0)
	if (fprintf(fi,"\n")<0)
        printf("write error");
  }
    fclose(fp);
    fclose(fs);
    fclose(fi);
    
    printf ("Black = %d\nWhite = %d\nGray  = %d\n", black, white, gray);
    printf ("Ratio (Bl) = %f\nRatio (Gr) = %f\nRatio (Wt) = %f\n", 
	    black/(480.0*480.0),  gray/(480.0*480.0),
	    white/(480.0*480.0));
    for(i=0;i<(256.0/gap);i++) { 
   printf("%f %f %d\n",i*gap,(i+1)*gap,density[i]); 
 }
    
  return 0;
}
