PROGRAM ADD_NODE

  IMPLICIT DOUBLE PRECISION (a-h,o-z)
  PARAMETER (NODM=4000,NLM=70)
  CHARACTER (len=20):: file1,file2
  CHARACTER (len=500):: string
  DOUBLE PRECISION, DIMENSION(NODM) :: X,Y
  DIMENSION BC(NODM,5)
  INTEGER, DIMENSION(NLM,50) :: IJK, IJK1, IJK2,IJKM
  INTEGER, DIMENSION (NLM,2) :: NINT,NINT1
  INTEGER, DIMENSION (NLM) :: NODE,MPE,MPG
  DIMENSION DISTANCES(25)
  INTEGER, DIMENSION (25) :: INITNODES

  TOL = 1.D-05
  NO_OF_DISTS=0
  NADD = 0
  NADDED = 0
  

  X=0
  Y=0
  IJK=0
  IJK1=0
  NINT=0
  file1='vchomo.inp'
  open(111,file=file1,ACTION='READ',POSITION='REWIND',STATUS='OLD')
      
      
  READ (111,*)
  READ (111,*) 
  READ (111,*) NX,NELX
  IF(NELX.EQ.1) FRACOUT=0.3
  IF(NELX.LT.10) FRACIN=0.2
  READ (111,*) 
  DO  I=1,NX
     READ(111, * ) N,X(N),Y(N)          
  ENDDO
  READ (111,*) 
  DO I=1,NELX
     READ (111,*) NEL,MPE(NEL),NODE(NEL),(IJK(NEL,J),J=1,NODE(NEL))
  ENDDO
  READ (111,*) 
  DO I=1,NELX
     READ (111,*) N,MPG(N),NINT(I,1),(IJK1(I,J),J=1,NINT(I,1))
  ENDDO
  READ (111,*) 
  DO I=1,NELX
     READ (111,*) N,NINT(I,2),(IJK2(I,J),J=1,NINT(I,2))
  ENDDO

  DO I=1,NELX

     NO_OF_DISTS = NODE(I)
     TOTAL_DISTANCE = 0
     MAX_NODES=0

     DO J=1,NO_OF_DISTS
        NODE1=IJK(I,J)
        IF(J.EQ.NO_OF_DISTS) THEN
           NODE2=IJK(I,1)
        ELSE
           NODE2=IJK(I,J+1)
        ENDIF
 
        DISTANCES(J) =SQRT((X(NODE1)-X(NODE2))**2+(Y(NODE1)-Y(NODE2))**2)
        TOTAL_DISTANCE = TOTAL_DISTANCE + DISTANCES(J)
        INITNODES(J) = IJK(I,J)
     ENDDO

     NNTBA = (55*TOTAL_DISTANCE)-NODE(I) !----HERE , THE NUMBER 55 CAN BE CHANGED TO ADD MORE NODES.
     MAX_NODES = 25-NODE(I)
     IF(NNTBA.GT.MAX_NODES)NNTBA = MAX_NODES

     IF(NNTBA.GT.0) THEN
        DO J=1,NO_OF_DISTS

           NODE1=INITNODES(J)
           IF(J.EQ.NO_OF_DISTS) THEN
              NODE2=INITNODES(1)
           ELSE
              NODE2=INITNODES(J+1)
           ENDIF
           NNTBA_SEG = (DISTANCES(J)/TOTAL_DISTANCE)*NNTBA
           NADD = IJK1(1,1)        
           CALL ADD_NODE_SPECIFIC(NNTBA_SEG,NADD,NODE1,NODE2,X,Y,IJK,IJK1,NINT,NINT1,NODE,NELX,NX+NADDED)
           NADDED = NADDED + NNTBA_SEG

        END DO
     ENDIF

  ENDDO

  open(222,file='finalmesh.inp')
  WRITE (222,*)
  WRITE (222,*)
  WRITE (222,51) NX+NADDED,NELX
  WRITE (222,*)
  DO  I=1,NX+NADDED
     WRITE (222,4) I,X(I),Y(I)
  ENDDO
  WRITE (222,*)
  DO I=1,NELX
     WRITE (222,51) I,MPE(I),NODE(I),(IJK(I,J),J=1,NODE(I))
  ENDDO
  WRITE (222,*) 
  DO I=1,NELX
     WRITE (222,51) I,MPG(I),NINT(I,1),(IJK1(I,J),J=1,NINT(I,1))
  ENDDO
  WRITE (222,*) 
  DO I=1,NELX
     WRITE (222,51) I,NINT(I,2),(IJK2(I,J),J=1,NINT(I,2))
  ENDDO
  read(111,10) string
  DO while(index(string,"Material").LE.0.AND.index(string,"material").LE.0) 
     write(222,10) trim(string)
     read(111,10) string
  ENDDO
  write (222,10) " Material properties"
  write(222,*) '2'
  write(222,*) '72.,0.22'
  write(222,*) '320.,0.25'
  write(222,*) '20'
  do I=1,NELX
     write(222,*) '1,3,4'
     write(222,*) '0,3,4'
     write(222,*) '0,3,2'
  enddo
  write(222,*) '1'
  do i=1,nelx
     write(222,*) '63'
  enddo
  write(222,*) ' 1st boundary'
  nbcount=0
  do i=1,NX
     if(abs(x(i)-0.d0).lt.tol.and.abs(y(i)-0.d0).lt.tol) then
        nbcount=nbcount+1
        bc(nbcount,1)=i
        bc(nbcount,2)=1
        bc(nbcount,3)=1
        bc(nbcount,4)=0.0
        bc(nbcount,5)=0.0
     elseif(abs(x(i)-0.d0).lt.tol.and.abs(y(i)-0.d0).gt.tol) then
        nbcount=nbcount+1
        bc(nbcount,1)=i
        bc(nbcount,2)=1
        bc(nbcount,3)=0
        bc(nbcount,4)=0.0
        bc(nbcount,5)=0.0
     elseif(abs(x(i)-0.d0).gt.tol.and.abs(y(i)-0.d0).lt.tol.and.abs(x(i)-xscale).gt.tol) then
        nbcount=nbcount+1
        bc(nbcount,1)=i
        bc(nbcount,2)=0
        bc(nbcount,3)=1
        bc(nbcount,4)=0.0
        bc(nbcount,5)=0.0
     elseif(abs(x(i)-xscale).lt.tol.and.abs(y(i)-0.d0).lt.tol) then
        nbcount=nbcount+1
        bc(nbcount,1)=i
        bc(nbcount,2)=1
        bc(nbcount,3)=1
        bc(nbcount,4)=appstrain
        bc(nbcount,5)=0.0
     elseif(abs(x(i)-xscale).lt.tol) then
        nbcount=nbcount+1
        bc(nbcount,1)=i
        bc(nbcount,2)=1
        bc(nbcount,3)=0
        bc(nbcount,4)=appstrain
        bc(nbcount,5)=0.0
     endif
  enddo
  write(222,*) nbcount
  do i=1,nbcount
     write(222,912) int(bc(i,1)),int(bc(i,2)),int(bc(i,3)),bc(i,4),bc(i,5)
  enddo
912 format(I4,X,I1,X,I1,X,F6.3,2X,F6.3)
  write(222,*) '2ND BOUNDARY'
  write(222,*) ' 0'
  write(222,*) '4 TH BOUNDARY'
  write(222,*) ' 0   1000000.00000000 '
  write(222,*) 
  write(222,*) 'macroscpoic strains'
  write(222,*) '3,0.00'
  write(222,*) '1,0.1'
  write(222,*) '3,0.'
  write(222,*) 
  write(222,*) 'REPEATABILITY BOUNDARY'
  write(222,*) '0'
  write(222,*) 

10 FORMAT(A)
4  FORMAT (I4,5(2X,E25.12))
51 FORMAT (20(I4,2X))
   REWIND(111)
   CLOSE(111)
   REWIND(222)
   CLOSE(222)

  STOP

END PROGRAM ADD_NODE




!C==========================================================================================

  SUBROUTINE ADD_NODE_SPECIFIC(NUM,N_ADD,IN1,IN2,X,Y,IJK,IJK1,NINT,NINT1,NODE,NELX,NX)

  IMPLICIT DOUBLE PRECISION (a-h,o-z)
  PARAMETER (NODM=4000,NLM=70)
  CHARACTER (len=20):: file1,file2
  CHARACTER (len=500):: string
  DOUBLE PRECISION, DIMENSION(NODM) :: X,Y
  INTEGER, DIMENSION(NLM,50) :: IJK, IJK1, IJK2
  INTEGER, DIMENSION (NLM,2) :: NINT,NINT1
  INTEGER, DIMENSION (NLM) :: NODE

  X1=X(IN1)
  Y1=Y(IN1)
  X2=X(IN2)
  Y2=Y(IN2)
  X_ADD=(X2-X1)/(NUM+1.D0)
  Y_ADD=(Y2-Y1)/(NUM+1.D0)
  
  IF(IN1.GE.N_ADD) THEN
      IN1=IN1+NUM
      PRINT*,'IN1 GE N_ADD'
  ENDIF

  IF(IN2.GE.N_ADD) THEN
     IN2=IN2+NUM
     PRINT*,'IN2 GE N_ADD'
  ENDIF

  IJ_FIND=0
  DO I=1,NELX

     DO I1=1,NODE(I)
        IF(IJK(I,I1).GE.N_ADD) IJK(I,I1)=IJK(I,I1)+NUM
     ENDDO
     DO I1=1,NINT(I,1)
        IF(IJK1(I,I1).GE.N_ADD) IJK1(I,I1)=IJK1(I,I1)+NUM
     ENDDO
     DO I1=1,NINT(I,2)
        IF(IJK2(I,I1).GE.N_ADD) IJK2(I,I1)=IJK2(I,I1)+NUM
     ENDDO
     IFIND=0
     II=1
     DO WHILE(IFIND.EQ.0.AND.II.LE.NODE(I))
        IF(IJK(I,II).EQ.IN1) THEN
           II_bef=II-1
           II_aft=II+1
           IF(II.EQ.1) II_bef=NODE(I)
           IF(II.EQ.NODE(I))  II_aft=1
           IF(IJK(I,II_bef).EQ.IN2.OR.IJK(I,II_aft).EQ.IN2) THEN
              IFIND=1
              IJ_FIND=1
              NODE(I)=NODE(I)+NUM
              IF(IJK(I,II_bef).EQ.IN2) THEN
                 DO JJ=NODE(I),II+NUM,-1
                    IJK(I,JJ)=IJK(I,JJ-NUM)
                 ENDDO
                 DO IJ=1,NUM
                    IJK(I,II+IJ-1)=N_ADD+NUM-IJ
                 ENDDO
              ELSEIF(IJK(I,II_aft).EQ.IN2) THEN

                 IF (II_aft.EQ.1) THEN
                    DO IJ=1,NUM
                       IJK(I,II+IJ)=N_ADD+IJ-1
                    ENDDO
                 ELSE
                    DO JJ=NODE(I),II+NUM+1,-1
                       IJK(I,JJ)=IJK(I,JJ-NUM)
                    ENDDO
                    DO IJ=1,NUM
                       IJK(I,II+IJ)=N_ADD+IJ-1
                    ENDDO
                 ENDIF
              ENDIF
           ENDIF
        ENDIF
        II=II+1
     ENDDO
     II=1
     DO WHILE(IFIND.EQ.0.AND.II.LE.NINT(I,1))
        IF(IJK1(I,II).EQ.IN1) THEN
           II_bef=II-1
           II_aft=II+1
           IF(II.EQ.1) II_bef=NINT(I,1)
           IF(II.EQ.NINT(I,1))  II_aft=1
           IF(IJK1(I,II_bef).EQ.IN2.OR.IJK1(I,II_aft).EQ.IN2) THEN
              IFIND=1
              IJ_FIND=1
              NINT(I,1)=NINT(I,1)+NUM
              IF(IJK1(I,II_bef).EQ.IN2) THEN
                 DO JJ=NINT(I,1),II+NUM,-1
                    IJK1(I,JJ)=IJK1(I,JJ-NUM)
                 ENDDO
                 DO IJ=1,NUM
                    IJK1(I,II+IJ-1)=N_ADD+NUM-IJ
                 ENDDO
              ELSEIF(IJK1(I,II_aft).EQ.IN2) THEN
                 IF (II_aft.EQ.1) THEN
                    DO IJ=1,NUM
                       IJK1(I,II+IJ)=N_ADD+IJ-1
                    ENDDO
                 ELSE
                    DO JJ=NINT(I,1),II+NUM+1,-1
                       IJK1(I,JJ)=IJK1(I,JJ-NUM)
                    ENDDO
                    DO IJ=1,NUM
                       IJK1(I,II+IJ)=N_ADD+IJ-1
                    ENDDO                   
                 ENDIF
              ENDIF
           ENDIF
        ENDIF
        II=II+1
     ENDDO
  ENDDO
  IF(IJ_FIND.EQ.0) THEN
     WRITE(*,*) "Cannot find the node!!"
     stop
  ENDIF

  DO JJ=NX,N_ADD,-1
     X(JJ+NUM)=X(JJ)
     Y(JJ+NUM)=Y(JJ)
  ENDDO
  DO II=1,NUM
     X(II+N_ADD-1)=X(IN1)+X_ADD*II
     Y(II+N_ADD-1)=Y(IN1)+Y_ADD*II
  ENDDO
    
  RETURN
  END
